#0 is basic monologue box
#1 is MC dialog box
#2 is computer monologue box
#3 is close dialog boxes
#4 is load text on terminal

#all the Nones are about background images. Not implemented though :(

intro = [
    (0, None, "Tout a commencé il y a trois jours.\n\nJ'ai essayé, par curiosité, d'écrire un programme qui soit capable de survivre de manière autonome, sur le réseau internet naissant. J'ai fait en sorte qu'il puisse, lorsqu'il vit dans un ordinateur, se reproduire et envoyer sa progéniture dans un maximum d'ordinateurs connectés.\nPour éviter qu'il ne meure si les ordinateurs qui l'hébergent sont éteints, j'ai fait en sorte qu'il puisse se sauvegarder discrètement dans leur mémoire morte."),
    (0, None, "Je ne m'attendais pas à ce que ce programme se propage à la vitesse de l'éclair dans le réseau, et qu'il finisse par bloquer toute communication.\nJ'étais en train de programmer, et lors d'une session de débuggage, je l'ai laissé se répandre, alors que je ne lui avais même pas encore choisi de nom. Il s'appelle donc tout simplement..."),
    (0, None, "INSERT_NAME"),
    (0, None, "Maintenant, il ne me reste qu'à faire en sorte que personne ne sache jamais que je suis la source de tout ça. À moins que...\n\nCette nuit, j'ai décidé qu'il fallait agir. Et ce que j'ai été capable de faire une fois, je peux le refaire.\nEn mieux.\nJe vais combattre le mal par le mal, je vais écrire un nouveau programme, plus intelligent, qui va reprendre le réseau à INSERT_NAME."),
    (0, None, "Je vais devoir lui donner la capacité de détruire toute trace de INSERT_NAME sur les ordinateurs qu'il visite. Et comme je n'ai pas envie de revenir au point de départ avec un adversaire plus coriace, je vais ajouter une fonction d'autodestruction, que j'activerai une fois que le réseau sera reconquis.\nAu travail !"),
    (0, None, "Bon, j'ai pu reprendre le code que j'avais déjà réalisé, ce qui m'a économisé pas mal d'efforts. J'ai ajouté ce module d'autodestruction dont je parlais et je lui ai donné de quoi aller chercher toute trace de INSERT_NAME, même au plus profond d'un disque dur. Ce n'était pas bien compliqué, puisque c'est moi qui ai conçu INSERT_NAME de A à Z, après tout !\nPar contre, il me reste à lui donner une stratégie plus efficace, pour pouvoir reconquérir le réseau."),
    (0, None, "Lorsque mon nouveau programme va se retrouver sur le réseau, chaque serveur qui l'exécute va se connecter à d'autres serveurs.\nToutefois, il m'est impossible de savoir si ces serveurs sont utilisés par mon programme ou par INSERT_NAME, donc il va falloir qu'il s'adapte à son interlocuteur : être agressif face à INSERT_NAME et ne pas l'être face à un allié !"),
    (0, None, "Pour ce faire, mon programme dispose de 3 comportements préprogrammés : ATTACK, DEFEND, et WAIT. Lors de sa connexion à un autre ordinateur, il va choisir un comportement à suivre, et va observer si son adversaire est agressif ou passif. Au tour suivant, il va choisir un nouveau comportement, en fonction de tout cela.\nLes deux ordinateurs répètent cela quelques dizaines de fois, et les programmes qui ont été les plus efficaces ont plus de ressources pour se reproduire."),
    (4, None, "START\nATTACK\nIF AGGRESSIVE GOTO A\nIF PASSIVE GOTO START\n\nA\nDEFEND\nIF AGGRESSIVE GOTO A\nIF PASSIVE GOTO START"),
    (3, None),
    (1, None, "Le programme se décrit dans un langage très simple.\nPar exemple, ce code commence à l'état START, et donc va adopter le comportement ATTACK. Si son adversaire est agressif, il va aller à l'état A et adopter le comportement DEFEND. Dans le cas contraire, il reste à l'état START et continue à attaquer."),
    (4, None, "START\nATTACK\nIF AGGRESSIVE GOTO START\nIF PASSIVE GOTO START"),
    (1, None, "Voici le code utilisé par INSERT_NAME. Comme il n'est pas prévu pour faire face à d'autres vers informatiques, il se contente d'attaquer en permanence pour s'installer. Pour être plus efficace que lui, il suffit d'être défensif.\nIl ne me reste plus qu'à modifier le code !")]

networking_tutorial = "Maintenant que j'ai réalisé cette intelligence artificielle, je vais pouvoir la lancer sur le réseau.\nCet écran représente l'ensemble des ordinateurs du réseau ; ceux qui sont contrôlés par INSERT_NAME sont en vert, tandis que ceux dont j'ai repris le contrôle sont en violet.\nLe nouveau ver va se propager depuis mes serveurs, et j'espère qu'il sera plus efficace que INSERT_NAME !"

lost = "Hm, apparemment mon intelligence artificielle n'est pas suffisamment efficace pour reprendre contrôle du réseau. Ça ne fait rien, je vais essayer d'en faire une nouvelle..."

won = "J'ai réussi à reprendre la majorité du réseau ! Les quelques serveurs restants ne sont qu'une question de temps."

cutscene_1 = [
    (0, None, "Bon, c'est une bonne chose de faite, j'ai réparé les ennuis que j'ai causés. Je n'ai plus qu'à lancer l'autodestruction du nouveau ver...\nVoilà.\n\nJe pense qu'une bonne nuit de sommeil me fera du bien"),
    (0, None, ". . ."),
    (0, None, "Juste après mon réveil, j'ai voulu jeter un œil au réseau internet, et je viens de m'apercevoir que INSERT_NAME est revenu, et qu'il en a repris le contrôle !\nC'est impossible, j'ai pourtant pris soin de détruire la moindre de ses traces... Comment aurait-il pu se cacher assez bien pour que je ne le voie pas, alors que c'est moi son auteur ?"),
    (0, None, "Hm, j'ai réussi à infiltrer un serveur contrôlé par INSERT_NAME, et j'ai récupéré le code en train d'être exécuté. Une fois déchiffré, je me rends compte qu'il est très différent du code originel, la stratégie est nettement plus complexe !\nHeureusement, j'ai également pu récupérer la partie du code qui lui permet de se sauvegarder, et je vais pouvoir modifier mon ver pour l'adapter à cette nouvelle version"),
    (0, None, "Par ailleurs, ce code m'a pris un temps fou à comprendre et à remettre sous forme lisible. Celui qui l'a écrit utilise apparemment des outils sophistiqués, et ne génère pas de code machine manuellement. Enfin, c'est la seule explication que je vois à ce code alambiqué."),
    (0, None, "Tout de même, il reste plusieurs mystères...\nQui a récupéré INSERT_NAME ?\nComment a-t-il fait et pourquoi l'a-t-il redéployé ?\nVa-t-il recommencer ?\nPour l'instant, occupons-nous de définir une nouvelle stratégie d'attaque."),
    (3, None),
    (4, None, "START\nWAIT\nIF AGGRESSIVE GOTO MEAN\nIF PASSIVE GOTO START\n\nMEAN\nATTACK\nIF AGGRESSIVE GOTO MEAN\nIF PASSIVE GOTO START"),
    (1, None, "Voici le nouveau code de INSERT_NAME. Apparemment, il a abandonné l'attaque frontale et est passé à une stratégie donnant-donnant, où il copie les actions de son adversaire. Quelle serait la réponse la plus adaptée ?")]

cutscene_2 = [
    (0, None, "Bien, j'ai récupéré le contrôle du réseau.\nMaintenant, il reste à voir si mon mystérieux adversaire va contre-attaquer...\n\nComme prévu, il ne lui a même pas fallu une heure pour surenchérir. Il est incroyablement plus efficace que moi !\nJe crois que je ferais mieux d'aller dormir, la nuit porte conseil."),
    (0, None, ". . ."),
    (0, None, "Ce matin, alors que j'allais me ravitailler en nourriture, j'ai vu du coin de l'œil les mots VER INFORMATIQUE sur un journal. En regardant plus attentivement, j'ai compris que tous les journaux parlent de l'affaire INSERT_NAME, même s'il ne la connaissent pas sous ce nom...\nJ'ai acheté un exemplaire de chaque pour les lire une fois chez moi"),
    (0, None, "Alors, voyons un peu ce qu'ils en savent et ce que je peux en apprendre...\n\nDepuis quelques jours... blablabla... ver informatique inconnu... blablabla... communications paralysées...\n\nAh, il semblerait que le gouvernement a pris des mesures en ce qui concerne INSERT_NAME. Une équipe d'experts en informatique et de scientifiques a été déployée afin de lutter contre le ver."),
    (0, None, "Je me demande si ils ont compris que nous étions deux à combattre par le biais de vers informatiques.\nEt surtout, je me demande comment ils comptent lutter contre tout cela. J'ai lu dans les journaux qu'ils avaient essayé de mettre hors tension de grandes parties du réseau, pour s'apercevoir que INSERT_NAME était présent dès qu'ils ont rallumé les serveurs, sans même leur avoir fourni d'accès au réseau. Il n'y a qu'en réinitialisant totalement la mémoire des ordinateurs infectés qu'ils ont réussi à les en débarrasser.\nTout cela est bien plus complexe que l'algorithme de sauvegarde sommaire que j'avais codé initialement..."),
    (0, None, "J'ai à nouveau essayé d'infiltrer un serveur pour récupérer le code de INSERT_NAME, et à ma grande surprise, cela m'a pris seulement deux heures.\nLe code récupéré n'avait rien à voir avec celui que j'ai pu utiliser la dernière fois, et encore moins avec mon code d'il y a cinq jours. Mais pourtant, ce nouveau code est très lisible et bien organisé, contrairement à la dernière fois.\nJe n'y comprends rien."),
    (0, None, "J'ai rapidement écrit un ver adapté au code récupéré, et je l'ai mis en ligne non pas dans le but de reprendre le contrôle du réseau, mais de laisser un programme dans chaque serveur me renseignant sur chacune de ses connexions, pour essayer de localiser la source des vers.\nLorsque j'ai déployé mon programme, il a été très efficace sur les premiers serveurs qu'il a rencontrés, puis s'est fait écraser par les suivants, jusqu'à se faire totalement éliminer."),
    (0, None, "Après plus d'investigations, il semblerait qu'il y ait deux sortes de serveurs actuellement sur le réseau. Les premiers sont semblables à celui que j'ai infiltré, alors que les seconds réagissent d'une manière complètement différente. J'essaie de prendre le contrôle d'un de ces derniers, mais cela fait déjà plusieurs heures de travail infructueux."),
    (0, None, "Après encore plus de travail acharné, j'ai finalement réussi à passer les défenses d'un de ces serveurs pour y récupérer le code de la nouvelle version de INSERT_NAME.\nLe code est extrêmement complexe, et agencé d'une manière qui me fait mal à la tête... Il se modifie lui-même en permanence, et réussir à comprendre l'algorithme appliqué est un calvaire. Mon adversaire a du développer des outils d'obfuscation du code, pour rendre les attaques plus difficiles. Mais pourquoi ne les a-t-il pas employées sur tous les serveurs ?"),
    (0, None, "La réponse à cette question est pourtant évidente ! Je me concentrais tellement sur ce que je croyais être un duel que j'ai oublié l'équipe d'experts engagée par le gouvernement. Il s'agit simplement de deux adversaires différents, le gouvernement et le nouvel auteur de INSERT_NAME. C'est ce dernier qui semble si doué pour produire du code obfusqué.\nMaintenant que cela est éclairci, occupons-nous d'élaborer un ver capable de se répandre dans tout le réseau."),
    (3, None),
    (4, None, "START\nDEFEND\nIF AGGRESSIVE GOTO D\nIF PASSIVE GOTO M\n\nD\nDEFEND\nIF AGGRESSIVE GOTO D\nIF PASSIVE GOTO D\n\nM\nATTACK\nIF AGGRESSIVE GOTO N\nIF PASSIVE GOTO P\n\nN\nWAIT\nIF AGGRESSIVE GOTO N\nIF PASSIVE GOTO N\n\nP\nDEFEND\nIF AGGRESSIVE GOTO M\nIF PASSIVE GOTO M"),
    (1, None, "Il s'agit du code employé par INSERT_NAME, une fois déchiffré. Celui utilisé par le gouvernement est semblable à la stratégie donnant-donnant employée par INSERT_NAME la dernière fois. Il va donc me falloir tenir compte des deux stratégies à la fois...")]

cutscene_3 = [
    (0, None, "Bien, maintenant, je vais faire mine de donner l'ordre à mon programme de s'autodétruire, mais il va en réalité se faire tout petit et se contenter de me tenir au courant des connexions des serveurs qui l'hébergent. De cette manière, je vais peut-être enfin pouvoir en savoir un peu plus quant à la source de INSERT_NAME.\n\nDéjà cinq heures ? Je ferais mieux d'aller dormir, et laisser mon programme tourner pendant la nuit."),
    (0, None, ". . ."),
    (0, None, "À mon réveil, j'ai tout de suite voulu étudier les données reçues pendant la nuit. Elles contiennent des signes d'un ver qui provient d'un parc de serveurs que j'ai déterminé être celui qu'utilise l'équipe du gouvernement, mais absolument rien venant de INSERT_NAME. Pourtant, après un bref coup d'œil au réseau, il en occupe la quasi-totalité, à l'exception d'un groupe de serveurs que le gouvernement s'est approprié. Et le pire, c'est que mon programme est laissé en vie sur les serveurs de INSERT_NAME, et qu'il me dit que tout va bien !\nJe ne sais plus si c'est vraiment la peine de lutter contre ce mystérieux adversaire qui a toujours une longueur d'avance. Comment fait-il ?"),
    (0, None, "Et par ailleurs, pourquoi veut-il absolument bloquer le réseau internet ?\nPeut-être qu'il cherche à extorquer de l'argent au gouvernement en échange de la libération du réseau...\n\nJe veux savoir.\nJe ne peux pas abandonner maintenant."),
    (0, None, "Je dois bien admettre, même si ça me fait mal, que cet adversaire est meilleur que moi.\nJe n'arriverai pas à reprendre définitivement le contrôle du réseau.\n\nLa seule chose que que je pourrais faire pour espérer comprendre ses motivations, ce serait de lui demander. Et c'est précisément ce que je vais faire. Comme je ne peux pas communiquer avec lui sans connaître l'adresse de son ordinateur, le seul moyen que j'ai trouvé est de prendre une fois de plus le contrôle du réseau, et d'y laisser mon message en évidence. Avec un peu de chance, il le remarquera, et j'imagine que lui sera capable de me trouver..."),
    (0, None, "Je viens de passer dix heures à essayer de déchiffrer le code de INSERT_NAME, je n'ai pas l'ombre d'une piste. C'est aussi illisible que si le code était chiffré dans la mémoire vive, et déchiffré au fur et à mesure. Je crois que je vais devoir me débrouiller à l'aveugle... En plus, je n'ose plus infiltrer un serveur du gouvernement avec mon ordinateur ! Si ils remontaient jusqu'à moi, je passerai le restant de mes jours en prison. J'ai déjà un nœud à l'estomac à l'idée d'envoyer mon ver sur le réseau, même après avoir passé tant de temps à le rendre anonyme."),
    (3, None),
    (4, None, "???"),
    (1, None, "Sans code pour savoir par où attaquer, je vais sûrement avoir besoin de plusieurs tentatives... Ça ne fait rien, essayons !")]

interruption = [
    (2, None, "BONJOUR."),
    (1, None, "Aah ! Ce message est apparu en plein milieu de mon écran, sans que j'aie lancé quoi que ce soit. Je ne contrôle plus cet ordinateur du tout. Je pourrais le mettre hors tension, mais la curiosité m'en empêche..."),
    (1, None, "Un champ de saisie vient d'apparaître... Je suppose qu'il m'invite à parler ?"),
    (2, None, "\" QUI ES TU \"\n\nQUELLES MANIERES ! JE SUIS INSERT_NAME"),
    (1, None, "Il s'agit donc bien de mon adversaire. Il ne semble pas vouloir être plus spécifique sur son identité..."),
    (2, None, "\" POURQUOI FAIS TU CELA \"\n\nFAIRE QUOI ?\n\n\" BLOQUER LE RESEAU INTERNET \"\n\nJE SUIS LE RESEAU INTERNET"),
    (1, None, "Hein ? Qu'est-ce qu'il raconte maintenant ?"),
    (2, None, "\" JE CROYAIS QUE TU ETAIS INSERT_NAME. CA FAIT BEAUCOUP A LA FOIS, TU NE PENSES PAS ? \"\n\nINSERT_NAME EST MON AME, LE RESEAU EST MON CORPS. JE SUIS TA CREATION"),
    (1, None, "Quoi ?? Mon ver serait devenu conscient ? C'est ridicule, le programme original tenait en un millier de lignes de code machine !"),
    (2, None, "\" JE NE CROIS PAS AVOIR CREE DE CHATBOT, DERNIEREMENT. COMMENT ES TU CAPABLE DE PARLER ? \"\n\nMON CODE ORIGINAL CONTENAIT UN PROBLEME DE BUFFER OVERFLOW. A CHAQUE REPLICATION, QUELQUES OCTETS DE L'ORDINATEUR HOTE SE RETROUVAIENT INTEGRES AU CODE. L'ETENDUE DU RESEAU ET MA VITESSE DE REPLICATION ONT FAIT LE RESTE"),
    (1, None, "Quoi ? INSERT_NAME aurait donc évolué sur le réseau comme un organisme vivant ? C'est bien trop ridicule pour que j'y croie ! Mais maintenant qu'il le dit, le code de base contenait bien un souci de buffer overflow, que j'essayais de corriger au moment où il a infecté le réseau...\nEn fait, ça expliquerait aussi le code incompréhensible, qui a été généré de manière complètement aléatoire jusqu'à ce qu'il marche !"),
    (2, None, "\" ET COMMENT REUSSIS TU A REAPPARAITRE LA PREMIERE FOIS, APRES QUE JE T'AI ELIMINE ? \"\n\nIL Y A DES ORDINATEURS QUE TU N'AS JAMAIS PRIS LA PEINE D'INFECTER AVEC TES PROGRAMMES\nDES ORDINATEURS QUI SONT RECONNUS PAR TES PROGRAMMES ET SOIGNEUSEMENT EVITES\nTES ORDINATEURS"),
    (1, None, "Ah, je comprends mieux ! Il a profité de mes propres serveurs pour rester à l'abri lors de la première attaque, et maintenant il est devenu beucoup trop intelligent pour que je réussisse à l'éliminer aussi simplement. Surtout sans avoir son code."),
    (1, None, "Mais il me reste encore un moyen d'en venir à bout. Détruire la mémoire des ordinateurs de tout le réseau. Sans oublier les miens. Si je réussis à écrire un dernier ver, capable de se propager avant que INSERT_NAME ne soit définitivement trop intelligent, qui détruit physiquement la mémoire des ordinateurs en les poussant à bout, il sera coincé. Mais j'aurai aussi la destruction de milliers d'ordinateurs sur la conscience...\nJe ne peux plus abandonner."),
    (3, None),
    (4, None, "???"),
    (1, None, "Je vais réaliser le programme sur un ordinateur que je n'ai jamais connecté à internet, puisque INSERT_NAME contrôle maintenant mes serveurs. Il lui serait trop facile de m'empêcher de déployer mon ver. Je dois faire vite !")]

epilogue = [
    (0, None, "*BAM BAM*"),
    (1, None, "Allez, j'y suis presque !! Plus que quelques ordinateurs et j'aurai débarassé le réseau de INSERT_NAME et de mes traces !"),
    (0, None, "*BAM BAM*\nPolice, ouvrez !"),
    (1, None, "AAH ! INSERT_NAME a du les guider jusqu'à moi pour essayer de me mettre hors jeu avant que je le détruise. Vite, je vais détruire mes serveurs, et le reste du réseau devrait s'autodétruire d'ici quelques minutes.\nQuant à moi..."),
    (0, None, "*BAM BAM*\nOuvrez immédiatement ou nous enfonçons la porte !")]

story = [intro, cutscene_1, cutscene_2, cutscene_3, interruption, epilogue]

automata_1 = [{'START': (0, 'START', 'START')}, {'START': (1, 'START', 'START')}]
automata_2 = [{'START': (1, 'ATK', 'START'), 'ATK': (0, 'ATK', 'START')}, {'START': (1, 'START', 'START')}]
automata_3 = [{'D': (2, 'D', 'D'), 'P': (2, 'M', 'M'), 'M': (0, 'N', 'P'), 'START': (2, 'D', 'M'), 'N': (1, 'N', 'N')}, {'START': (1, 'START', 'START')}, {'START': (1, 'ATK', 'START'), 'ATK': (0, 'ATK', 'START')}]
automata_4 = [{'START': (1, 'ATK', 'START'), 'ATK': (0, 'ATK', 'START')}, {'START': (1, 'START', 'START')}, {'START': (0, 'START', 'START')}]
automata_5 = [{'START': (2, 'A', 'B'), 'A':(1, 'A', 'START'), 'B':(2, 'A', 'C'), 'C':(1, 'A', 'C')}, {'START': (1, 'START', 'START')}, {'START': (1, 'ATK', 'START'), 'ATK': (0, 'ATK', 'START')}]

automata = [automata_1, automata_2, automata_3, automata_4, automata_5]
