def save_settings (settings):
    try:
        file = open ("INSERT_NAME.ini", "w")
        for field in settings:
            file.write (field + ":" + str(settings[field]) + "\n")
        file.close()
    except:
        raise RuntimeError ("Settings could not be saved.")

def default_settings ():
    return {"window_size":(1200,800), "font_size":30}

def load_settings ():
    settings = {}
    opened = False
    try:
        file = open ("INSERT_NAME.ini")
        opened = True
        for line in file.readlines ():
            try:
                content = line.split (":")
                settings[content[0]] = eval (content[1])
            except:
                pass
        for mandatory in default_settings ():
            if not (mandatory in settings):
                raise Exception (mandatory + " not present in saved settings")
    except:
        print ("Settings file inexistant or corrupted. Generating new file...")
        settings = default_settings ()
        save_settings (settings)
    if opened:
        file.close ()
    return settings

